'----------------------------------------------------------------------------------------
' Las register definitions
'----------------------------------------------------------------------------------------

' COG register definitions

PAR     EQU             $1F0
CNT     EQU             $1F1
INA     EQU             $1F2
INB     EQU             $1F3
OUTA    EQU             $1F4
OUTB    EQU             $1F5
DIRA    EQU             $1F6
DIRB    EQU             $1F7
CTRA    EQU             $1F8
CTRB    EQU             $1F9
FRQA    EQU             $1FA
FRQB    EQU             $1FB
PHSA    EQU             $1FC
PHSB    EQU             $1FD
VCFG    EQU             $1FE
VSCL    EQU             $1FF

' LMM register definitions

LMMBASE     EQU             $0
LMMFCACHE   EQU             $080
LMMDCACHE   EQU             $100
LMMREGS     EQU             $180

PC      	EQU     $1E0    ' Program Counter
SP      	EQU     $1E1    ' Stack Pointer
BP      	EQU     $1E2    ' Base Pointer
FLAGS   	EQU     $1E3    ' Flags
R0      	EQU     $1E4    ' General Purpose Register, also TOS
R1      	EQU     $1E5    ' General Purpose Register
R2      	EQU     $1E6    ' General Purpose Register
R3      	EQU     $1E7    ' General Purpose Register
R4      	EQU     $1E8    ' General Purpose Register
R5      	EQU     $1E9    ' General Purpose Register
R6      	EQU     $1EA    ' General Purpose Register
R7      	EQU     $1EB    ' General Purpose Register
R8      	EQU     $1EC    ' General Purpose Register
R9      	EQU     $1ED    ' General Purpose Register
R10     	EQU     $1EE    ' General Purpose Register
R11     	EQU     $1EF    ' General Purpose Register
TOS     	EQU     $1E4    ' Top of Stack register

