'----------------------------------------------------------------------------------------
' testing Las
'
' Las regression test file
'
' Copyright 2009 William Henning
'
' http://mikronatus.com
'
' NOTE: DO NOT USE 'EQU' to define non-cog addresses, as EQU values
' WILL NOT BE RELOCATED! USE LABELS, THEY WILL BE RELOCATED!
'
' Bill's TODO list:
' - add \" quoting inside strings
' - fix expressions for src/dest, disable for now
' - add error messages for instructions illegal in LMM mode
' - far jmp to sub pc,#? for in-range jumps backward
' - add LMM transparent version of DJNZ if target label is already defined and in range
' - finish macros & conditional assembly
'
'----------------------------------------------------------------------------------------

        output  image           ' eeprom image file

        org		0

HZ      long    	5000000         ' clock speed in HZ
CR      byte    	4               ' clock mode
CS      byte    	0               ' checksum (to 0)
PBASE   word    	$0010           ' must be $0010
VBASE   word    	$1000           ' number of longs loaded
DBASE   word    	$0018           ' first word above markers
PCURR   word    	$0020           ' spin code to execute
DCURR   word    	$0010           ' point to local stack
LNG1    long    	$FFF9FFFF       ' below local stack must be $FFF9FFFF
LNG2    long    	$FFF9FFFF       ' below local stack must be $FFF9FFFF
STRTUP  byte    	$35             ' push #0
        byte    	$37,$04         ' push #$20
        byte    	$35             ' push #$18
        byte    	$2C             ' coginit(0,$20,0)
        byte    	0, 0, 0         ' filler

' I found the above startup code on the forums, it loads and runs a cog from code
' at hub location $0020.

' the following code is my ugly regression test for COG mode - output should be
' identical with the pasmtest.spin file EXCEPT for the first $20 bytes.

id      equ     123
src     equ     $20
dst     equ     $30

        cog 0

start   abs     dst,src

        absneg  1,2
        add     3,#4
        addabs  $a,$b
        adds    1,src
        addsx   dst,2
        addx    dst,src
        and     dst,src
        andn    dst,src
        call    #start
        clkset  dst	
        cmp     dst,src
        cmps    dst,src
        cmpsub  dst,src
        cmpsx   dst,src
        cmpx    dst,src

        cogid   dst
        coginit dst
        cogstop dst

start_ret	  djnz    dst,#start_ret

        hubop   dst,src

        jmp     dst
        jmpret  dst,src
        lockclr dst
        locknew dst
        lockret dst
        lockset dst

        max     dst,src
        maxs    dst,src
        min     dst,src
        mins    dst,src
        mov     dst,src

        movd    dst,src
        movi    dst,src
        movs    dst,src
        muxc    dst,src
        muxnc   dst,src
        muxnz   dst,src
        muxz    dst,src
        neg     dst,src
        negc    dst,src
        negnc   dst,src
        negnz   dst,src
        negz    dst,src
        nop
        or      dst,src
        rdbyte  dst,src
        rdlong  dst,src
        rdword  dst,src
        rcl     dst,src
        rcr     dst,src
        ret
        rev     dst,src
        rol     dst,src
        ror     dst,src
        sar     dst,src
        shl     dst,src
        shr     dst,src
        sub     dst,src
        subabs  dst,src
        subs    dst,src
        subsx   dst,src
        subx    dst,src
        sumc    dst,src
        sumnc   dst,src
        sumnz   dst,src
        sumz    dst,src
        test    dst,src
        tjnz    dst,src
        tjz     dst,src
        waitcnt dst,src
        waitpeq dst,src
        waitpne dst,src
        waitvid dst,src
        wrbyte  dst,src
        wrlong  dst,src
        wrword  dst,src
        xor     dst,src

'------------------------------------------------
' phase 2 test - immediate flag & effect codes
'------------------------------------------------

        cmps    dst,src nr
        cmps    dst,#src nr
        cmps    dst,src wr
        cmps    dst,src wc
        cmps    dst,src wz

'------------------------------------------------
' phase 3 test - condition codes
'------------------------------------------------

                cmps  dst,src
 if_always      cmps  dst,src
 if_never       cmps  dst,src
 if_e           cmps  dst,src
 if_ne          cmps  dst,src
 if_a           cmps  dst,src
 if_b           cmps  dst,src
 if_ae          cmps  dst,src
 if_be          cmps  dst,src
 if_c           cmps  dst,src
 if_nc          cmps  dst,src
 if_z           cmps  dst,src
 if_nz          cmps  dst,src
 if_c_eq_z      cmps  dst,src
 if_c_ne_z      cmps  dst,src
 if_c_and_z     cmps  dst,src
 if_c_and_nz    cmps  dst,src
 if_nc_and_z    cmps  dst,src
 if_nc_and_nz   cmps  dst,src
 if_c_or_z      cmps  dst,src
 if_c_or_nz     cmps  dst,src
 if_nc_or_z     cmps  dst,src
 if_nc_or_nz    cmps  dst,src
 if_z_eq_c      cmps  dst,src
 if_z_ne_c      cmps  dst,src
 if_z_and_c     cmps  dst,src
 if_z_and_nc    cmps  dst,src
 if_nz_and_c    cmps  dst,src
 if_nz_and_nc   cmps  dst,src
 if_z_or_c      cmps  dst,src
 if_z_or_nc     cmps  dst,src
 if_nz_or_c     cmps  dst,src
 if_nz_or_nc    cmps  dst,src

	end

